diff --git a/src/responder/nss/nsssrv_netgroup.c b/src/responder/nss/nsssrv_netgroup.c
index 9a78c1119c2f4e06e43ebec29ace775adc997e08..c0ea54c9b65626b86f8bc965fefae0d31cd157da 100644
--- a/src/responder/nss/nsssrv_netgroup.c
+++ b/src/responder/nss/nsssrv_netgroup.c
@@ -94,6 +94,8 @@ static void nss_cmd_setnetgrent_done(struct tevent_req *req);
 int nss_cmd_setnetgrent(struct cli_ctx *client)
 {
     struct nss_cmd_ctx *cmdctx;
+    struct cli_protocol *pctx;
+    struct nss_state_ctx *state_ctx;
     struct tevent_req *req;
     const char *rawname;
     uint8_t *body;
@@ -101,7 +103,8 @@ int nss_cmd_setnetgrent(struct cli_ctx *client)
     errno_t ret = EOK;
 
     /* Reset the result cursor to zero */
-    client->netgrent_cur = 0;
+    state_ctx = talloc_get_type(client->state_ctx, struct nss_state_ctx);
+    state_ctx->netgrent_cur = 0;
 
     cmdctx = talloc_zero(client, struct nss_cmd_ctx);
     if (!cmdctx) {
@@ -109,8 +112,10 @@ int nss_cmd_setnetgrent(struct cli_ctx *client)
     }
     cmdctx->cctx = client;
 
+    pctx = talloc_get_type(client->protocol_ctx, struct cli_protocol);
+
     /* get netgroup name to query */
-    sss_packet_get_body(client->creq->in, &body, &blen);
+    sss_packet_get_body(pctx->creq->in, &body, &blen);
 
     /* if not terminated fail */
     if (body[blen -1] != '\0') {
@@ -184,10 +189,12 @@ static struct tevent_req *setnetgrent_send(TALLOC_CTX *mem_ctx,
     struct tevent_req *req;
     struct setnetgrent_ctx *state;
     struct nss_dom_ctx *dctx;
-
     struct cli_ctx *client = cmdctx->cctx;
-    struct nss_ctx *nctx =
-            talloc_get_type(client->rctx->pvt_ctx, struct nss_ctx);
+    struct nss_ctx *nctx;
+    struct nss_state_ctx *state_ctx;
+
+    nctx = talloc_get_type(client->rctx->pvt_ctx, struct nss_ctx);
+    state_ctx = talloc_get_type(client->state_ctx, struct nss_state_ctx);
 
     req = tevent_req_create(mem_ctx, &state, struct setnetgrent_ctx);
     if (!req) {
@@ -227,8 +234,8 @@ static struct tevent_req *setnetgrent_send(TALLOC_CTX *mem_ctx,
         }
 
         /* Save the netgroup name for getnetgrent */
-        client->netgr_name = talloc_strdup(client, state->netgr_shortname);
-        if (!client->netgr_name) {
+        state_ctx->netgr_name = talloc_strdup(client, state->netgr_shortname);
+        if (!state_ctx->netgr_name) {
             ret = ENOMEM;
             goto error;
         }
@@ -238,8 +245,8 @@ static struct tevent_req *setnetgrent_send(TALLOC_CTX *mem_ctx,
         cmdctx->check_next = true;
 
         /* Save the netgroup name for getnetgrent */
-        client->netgr_name = talloc_strdup(client, rawname);
-        if (!client->netgr_name) {
+        state_ctx->netgr_name = talloc_strdup(client, rawname);
+        if (!state_ctx->netgr_name) {
             ret = ENOMEM;
             goto error;
         }
@@ -272,6 +279,7 @@ static errno_t setnetgrent_retry(struct tevent_req *req)
     struct setnetgrent_ctx *state;
     struct cli_ctx *client;
     struct nss_ctx *nctx;
+    struct nss_state_ctx *state_ctx;
     struct nss_cmd_ctx *cmdctx;
     struct nss_dom_ctx *dctx;
 
@@ -280,13 +288,14 @@ static errno_t setnetgrent_retry(struct tevent_req *req)
     cmdctx = state->cmdctx;
     client = cmdctx->cctx;
     nctx = talloc_get_type(client->rctx->pvt_ctx, struct nss_ctx);
+    state_ctx = talloc_get_type(client->state_ctx, struct nss_state_ctx);
 
     dctx->check_provider = NEED_CHECK_PROVIDER(dctx->domain->provider);
 
     /* Is the result context already available?
      * Check for existing lookups for this netgroup
      */
-    ret = get_netgroup_entry(nctx, client->netgr_name, &state->netgr);
+    ret = get_netgroup_entry(nctx, state_ctx->netgr_name, &state->netgr);
     if (ret == EOK) {
         /* Another process already requested this netgroup
          * Check whether it's ready for processing.
@@ -328,7 +337,7 @@ static errno_t setnetgrent_retry(struct tevent_req *req)
          * so we can remove it in the destructor
          */
         state->netgr->name = talloc_strdup(state->netgr,
-                                           client->netgr_name);
+                                           state_ctx->netgr_name);
         if (!state->netgr->name) {
             talloc_free(state->netgr);
             ret = ENOMEM;
@@ -698,7 +707,7 @@ static void nss_cmd_setnetgrent_done(struct tevent_req *req)
     struct sss_packet *packet;
     uint8_t *body;
     size_t blen;
-
+    struct cli_protocol *pctx;
     struct nss_cmd_ctx *cmdctx =
             tevent_req_callback_data(req, struct nss_cmd_ctx);
 
@@ -710,16 +719,18 @@ static void nss_cmd_setnetgrent_done(struct tevent_req *req)
         return;
     }
 
+    pctx = talloc_get_type(cmdctx->cctx->protocol_ctx, struct cli_protocol);
+
     /* Either we succeeded or no domains were eligible */
-    ret = sss_packet_new(cmdctx->cctx->creq, 0,
-                         sss_packet_get_cmd(cmdctx->cctx->creq->in),
-                         &cmdctx->cctx->creq->out);
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret == EOK) {
         if (reqret == ENOENT) {
             /* Notify the caller that this entry wasn't found */
-            sss_cmd_empty_packet(cmdctx->cctx->creq->out);
+            sss_cmd_empty_packet(pctx->creq->out);
         } else {
-            packet = cmdctx->cctx->creq->out;
+            packet = pctx->creq->out;
             ret = sss_packet_grow(packet, 2*sizeof(uint32_t));
             if (ret != EOK) {
                 DEBUG(SSSDBG_CRIT_FAILURE, "Couldn't grow the packet\n");
@@ -749,6 +760,7 @@ int nss_cmd_getnetgrent(struct cli_ctx *client)
 {
     errno_t ret;
     struct nss_ctx *nctx;
+    struct nss_state_ctx *state_ctx;
     struct nss_cmd_ctx *cmdctx;
     struct getent_ctx *netgr;
     struct tevent_req *req;
@@ -762,8 +774,9 @@ int nss_cmd_getnetgrent(struct cli_ctx *client)
     cmdctx->cctx = client;
 
     nctx = talloc_get_type(client->rctx->pvt_ctx, struct nss_ctx);
+    state_ctx = talloc_get_type(client->state_ctx, struct nss_state_ctx);
 
-    if (!client->netgr_name) {
+    if (!state_ctx->netgr_name) {
         /* Tried to run getnetgrent without a preceding
          * setnetgrent. There is no way to determine which
          * netgroup is being requested.
@@ -772,13 +785,13 @@ int nss_cmd_getnetgrent(struct cli_ctx *client)
     }
 
     /* Look up the results from the hash */
-    ret = get_netgroup_entry(nctx, client->netgr_name, &netgr);
+    ret = get_netgroup_entry(nctx, state_ctx->netgr_name, &netgr);
     if (ret == ENOENT) {
         /* We need to invoke an implicit setnetgrent() to
          * wait for the result object to become available.
          */
 
-        req = setnetgrent_send(cmdctx, client->netgr_name, cmdctx);
+        req = setnetgrent_send(cmdctx, state_ctx->netgr_name, cmdctx);
         if (!req) {
             return nss_cmd_done(cmdctx, EIO);
         }
@@ -797,7 +810,7 @@ int nss_cmd_getnetgrent(struct cli_ctx *client)
         /* We need to invoke an implicit setnetgrent() to
          * wait for the result object to become available.
          */
-        req = setnetgrent_send(cmdctx, client->netgr_name, cmdctx);
+        req = setnetgrent_send(cmdctx, state_ctx->netgr_name, cmdctx);
         if (!req) {
             return nss_cmd_done(cmdctx, EIO);
         }
@@ -806,12 +819,12 @@ int nss_cmd_getnetgrent(struct cli_ctx *client)
         return EOK;
     } else if (!netgr->found) {
         DEBUG(SSSDBG_TRACE_FUNC,
-              "Results for [%s] not found.\n", client->netgr_name);
+              "Results for [%s] not found.\n", state_ctx->netgr_name);
         return ENOENT;
     }
 
     DEBUG(SSSDBG_TRACE_FUNC,
-          "Returning results for [%s]\n", client->netgr_name);
+          "Returning results for [%s]\n", state_ctx->netgr_name);
 
     /* Read the result strings */
     ret = nss_cmd_getnetgrent_process(cmdctx, netgr);
@@ -827,8 +840,11 @@ static void setnetgrent_implicit_done(struct tevent_req *req)
     struct getent_ctx *netgr;
     struct nss_cmd_ctx *cmdctx =
             tevent_req_callback_data(req, struct nss_cmd_ctx);
-    struct nss_ctx *nctx =
-            talloc_get_type(cmdctx->cctx->rctx->pvt_ctx, struct nss_ctx);
+    struct nss_ctx *nctx;
+    struct nss_state_ctx *state_ctx;
+
+    nctx = talloc_get_type(cmdctx->cctx->rctx->pvt_ctx, struct nss_ctx);
+    state_ctx = talloc_get_type(cmdctx->cctx->state_ctx, struct nss_state_ctx);
 
     ret = setnetgrent_recv(req);
     talloc_zfree(req);
@@ -851,7 +867,7 @@ static void setnetgrent_implicit_done(struct tevent_req *req)
     }
 
     /* Look up the results from the hash */
-    ret = get_netgroup_entry(nctx, cmdctx->cctx->netgr_name, &netgr);
+    ret = get_netgroup_entry(nctx, state_ctx->netgr_name, &netgr);
     if (ret == ENOENT) {
         /* Critical error. This should never happen */
         DEBUG(SSSDBG_FATAL_FAILURE,
@@ -888,23 +904,25 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
 static errno_t nss_cmd_getnetgrent_process(struct nss_cmd_ctx *cmdctx,
                                            struct getent_ctx *netgr)
 {
-    struct cli_ctx *client = cmdctx->cctx;
+    struct cli_protocol *pctx;
     uint8_t *body;
     size_t blen;
     uint32_t num;
     errno_t ret;
 
+    pctx = talloc_get_type(cmdctx->cctx->protocol_ctx, struct cli_protocol);
+
     /* get max num of entries to return in one call */
-    sss_packet_get_body(client->creq->in, &body, &blen);
+    sss_packet_get_body(pctx->creq->in, &body, &blen);
     if (blen != sizeof(uint32_t)) {
         return EINVAL;
     }
     SAFEALIGN_COPY_UINT32(&num, body, NULL);
 
     /* create response packet */
-    ret = sss_packet_new(client->creq, 0,
-                         sss_packet_get_cmd(client->creq->in),
-                         &client->creq->out);
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret != EOK) {
         return ret;
     }
@@ -912,18 +930,18 @@ static errno_t nss_cmd_getnetgrent_process(struct nss_cmd_ctx *cmdctx,
     if (!netgr->entries || netgr->entries[0] == NULL) {
         /* No entries */
         DEBUG(SSSDBG_FUNC_DATA, "No entries found\n");
-        ret = sss_cmd_empty_packet(client->creq->out);
+        ret = sss_cmd_empty_packet(pctx->creq->out);
         if (ret != EOK) {
             return nss_cmd_done(cmdctx, ret);
         }
         goto done;
     }
 
-    ret = nss_cmd_retnetgrent(client, netgr->entries, num);
+    ret = nss_cmd_retnetgrent(cmdctx->cctx, netgr->entries, num);
 
 done:
-    sss_packet_set_error(client->creq->out, ret);
-    sss_cmd_done(client, cmdctx);
+    sss_packet_set_error(pctx->creq->out, ret);
+    sss_cmd_done(cmdctx->cctx, cmdctx);
 
     return EOK;
 }
@@ -940,32 +958,37 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
     uint8_t *body;
     size_t blen, rp;
     errno_t ret;
-    struct sss_packet *packet = client->creq->out;
-    int num, start;
+    struct cli_protocol *pctx;
+    struct nss_state_ctx *state_ctx;
+    struct sss_packet *packet;
+    int num, start, cur;
+
+    state_ctx = talloc_get_type(client->state_ctx, struct nss_state_ctx);
+    pctx = talloc_get_type(client->protocol_ctx, struct cli_protocol);
+    packet = pctx->creq->out;
 
     /* first 2 fields (len and reserved), filled up later */
     rp = 2*sizeof(uint32_t);
     ret = sss_packet_grow(packet, rp);
     if (ret != EOK) return ret;
 
-    start = client->netgrent_cur;
+    start = cur = state_ctx->netgrent_cur;
     num = 0;
-    while (entries[client->netgrent_cur] &&
-           (client->netgrent_cur - start) < count) {
-        if (entries[client->netgrent_cur]->type == SYSDB_NETGROUP_TRIPLE_VAL) {
+    while (entries[cur] && (cur - start) < count) {
+        if (entries[cur]->type == SYSDB_NETGROUP_TRIPLE_VAL) {
             hostlen = 1;
-            if (entries[client->netgrent_cur]->value.triple.hostname) {
-                hostlen += strlen(entries[client->netgrent_cur]->value.triple.hostname);
+            if (entries[cur]->value.triple.hostname) {
+                hostlen += strlen(entries[cur]->value.triple.hostname);
             }
 
             userlen = 1;
-            if (entries[client->netgrent_cur]->value.triple.username) {
-                userlen += strlen(entries[client->netgrent_cur]->value.triple.username);
+            if (entries[cur]->value.triple.username) {
+                userlen += strlen(entries[cur]->value.triple.username);
             }
 
             domainlen = 1;
-            if (entries[client->netgrent_cur]->value.triple.domainname) {
-                domainlen += strlen(entries[client->netgrent_cur]->value.triple.domainname);
+            if (entries[cur]->value.triple.domainname) {
+                domainlen += strlen(entries[cur]->value.triple.domainname);
             }
 
             len = sizeof(uint32_t) + hostlen + userlen + domainlen;
@@ -981,7 +1004,7 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
                 body[rp] = '\0';
             } else {
                 memcpy(&body[rp],
-                       entries[client->netgrent_cur]->value.triple.hostname,
+                       entries[cur]->value.triple.hostname,
                        hostlen);
             }
             rp += hostlen;
@@ -990,7 +1013,7 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
                 body[rp] = '\0';
             } else {
                 memcpy(&body[rp],
-                       entries[client->netgrent_cur]->value.triple.username,
+                       entries[cur]->value.triple.username,
                        userlen);
             }
             rp += userlen;
@@ -999,19 +1022,19 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
                 body[rp] = '\0';
             } else {
                 memcpy(&body[rp],
-                       entries[client->netgrent_cur]->value.triple.domainname,
+                       entries[cur]->value.triple.domainname,
                        domainlen);
             }
             rp += domainlen;
-        } else if (entries[client->netgrent_cur]->type == SYSDB_NETGROUP_GROUP_VAL) {
-            if (entries[client->netgrent_cur]->value.groupname == NULL ||
-                entries[client->netgrent_cur]->value.groupname[0] == '\0') {
+        } else if (entries[cur]->type == SYSDB_NETGROUP_GROUP_VAL) {
+            if (entries[cur]->value.groupname == NULL ||
+                entries[cur]->value.groupname[0] == '\0') {
                 DEBUG(SSSDBG_CRIT_FAILURE,
                       "Empty netgroup member. Please check your cache.\n");
                 continue;
             }
 
-            grouplen = 1 + strlen(entries[client->netgrent_cur]->value.groupname);
+            grouplen = 1 + strlen(entries[cur]->value.groupname);
 
             len = sizeof(uint32_t) + grouplen;
 
@@ -1025,7 +1048,7 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
             SAFEALIGN_SET_UINT32(&body[rp], SSS_NETGR_REP_GROUP, &rp);
 
             memcpy(&body[rp],
-                   entries[client->netgrent_cur]->value.groupname,
+                   entries[cur]->value.groupname,
                    grouplen);
             rp += grouplen;
         } else {
@@ -1036,7 +1059,8 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
         }
 
         num++;
-        client->netgrent_cur++;
+        cur++;
+        state_ctx->netgrent_cur = cur;
     }
 
     sss_packet_get_body(packet, &body, &blen);
@@ -1052,20 +1076,25 @@ static errno_t nss_cmd_retnetgrent(struct cli_ctx *client,
 
 int nss_cmd_endnetgrent(struct cli_ctx *client)
 {
+    struct cli_protocol *pctx;
+    struct nss_state_ctx *state_ctx;
     errno_t ret;
 
+    pctx = talloc_get_type(client->protocol_ctx, struct cli_protocol);
+    state_ctx = talloc_get_type(client->state_ctx, struct nss_state_ctx);
+
     /* create response packet */
-    ret = sss_packet_new(client->creq, 0,
-                         sss_packet_get_cmd(client->creq->in),
-                         &client->creq->out);
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
 
     if (ret != EOK) {
         return ret;
     }
 
     /* Reset the indices so that subsequent requests start at zero */
-    client->netgrent_cur = 0;
-    talloc_zfree(client->netgr_name);
+    state_ctx->netgrent_cur = 0;
+    talloc_zfree(state_ctx->netgr_name);
 
     sss_cmd_done(client, NULL);
     return EOK;
diff --git a/src/responder/nss/nsssrv_private.h b/src/responder/nss/nsssrv_private.h
index 72f7b75604567f9b95937018e54ba2d60b771f9b..79c7b7265f66f57e0ea89fe192a1da4f8992f1a3 100644
--- a/src/responder/nss/nsssrv_private.h
+++ b/src/responder/nss/nsssrv_private.h
@@ -27,6 +27,19 @@
 
 #include <dhash.h>
 
+struct nss_state_ent {
+    int dom_idx;
+    int cur;
+};
+
+struct nss_state_ctx {
+    struct nss_state_ent pwent;
+    struct nss_state_ent grent;
+    struct nss_state_ent svcent;
+    char *netgr_name;
+    int netgrent_cur;
+};
+
 struct nss_cmd_ctx {
     struct cli_ctx *cctx;
     enum sss_cli_command cmd;
@@ -136,4 +149,6 @@ void nss_update_initgr_memcache(struct nss_ctx *nctx,
                                 const char *name, const char *domain,
                                 int gnum, uint32_t *groups);
 
+int nss_connection_setup(struct cli_ctx *cctx);
+
 #endif /* NSSSRV_PRIVATE_H_ */
diff --git a/src/responder/nss/nsssrv_services.c b/src/responder/nss/nsssrv_services.c
index a9fdeb6c9dba7ac5480e2789fc0b8a37e1c2abe1..0fad1d9bd0e2fca03e5c427801e5c1db8de10a32 100644
--- a/src/responder/nss/nsssrv_services.c
+++ b/src/responder/nss/nsssrv_services.c
@@ -795,6 +795,7 @@ nss_cmd_getserv_done(struct tevent_req *req);
 int nss_cmd_getservbyname(struct cli_ctx *cctx)
 {
     errno_t ret;
+    struct cli_protocol *pctx;
     struct nss_cmd_ctx *cmdctx;
     struct nss_dom_ctx *dctx;
     char *domname;
@@ -816,8 +817,10 @@ int nss_cmd_getservbyname(struct cli_ctx *cctx)
     }
     dctx->cmdctx = cmdctx;
 
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+
     /* get service name and protocol */
-    sss_packet_get_body(cctx->creq->in, &body, &blen);
+    sss_packet_get_body(pctx->creq->in, &body, &blen);
     /* if not terminated fail */
     if (body[blen -1] != '\0') {
         ret = EINVAL;
@@ -991,7 +994,7 @@ nss_cmd_getserv_done(struct tevent_req *req)
 {
     errno_t ret, reqret;
     unsigned int i;
-
+    struct cli_protocol *pctx;
     struct nss_dom_ctx *dctx =
             tevent_req_callback_data(req, struct nss_dom_ctx);
     struct nss_cmd_ctx *cmdctx = dctx->cmdctx;
@@ -1005,17 +1008,19 @@ nss_cmd_getserv_done(struct tevent_req *req)
         return;
     }
 
+    pctx = talloc_get_type(cmdctx->cctx->protocol_ctx, struct cli_protocol);
+
     /* Either we succeeded or no domains were eligible */
-    ret = sss_packet_new(cmdctx->cctx->creq, 0,
-                         sss_packet_get_cmd(cmdctx->cctx->creq->in),
-                         &cmdctx->cctx->creq->out);
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret == EOK) {
         if (reqret == ENOENT) {
             /* Notify the caller that this entry wasn't found */
-            ret = sss_cmd_empty_packet(cmdctx->cctx->creq->out);
+            ret = sss_cmd_empty_packet(pctx->creq->out);
         } else {
             i = dctx->res->count;
-            ret = fill_service(cmdctx->cctx->creq->out,
+            ret = fill_service(pctx->creq->out,
                                dctx->domain,
                                dctx->protocol,
                                dctx->res->msgs,
@@ -1110,6 +1115,7 @@ done:
 int nss_cmd_getservbyport(struct cli_ctx *cctx)
 {
     errno_t ret;
+    struct cli_protocol *pctx;
     struct nss_cmd_ctx *cmdctx;
     struct nss_dom_ctx *dctx;
     uint16_t port;
@@ -1130,8 +1136,10 @@ int nss_cmd_getservbyport(struct cli_ctx *cctx)
     }
     dctx->cmdctx = cmdctx;
 
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+
     /* get service port and protocol */
-    sss_packet_get_body(cctx->creq->in, &body, &blen);
+    sss_packet_get_body(pctx->creq->in, &body, &blen);
     /* if not terminated fail */
     if (body[blen -1] != '\0') {
         ret = EINVAL;
@@ -1199,14 +1207,17 @@ setservent_send(TALLOC_CTX *mem_ctx, struct cli_ctx *cctx)
     struct setservent_ctx *state;
     struct sss_domain_info *dom;
     struct setent_step_ctx *step_ctx;
-    struct nss_ctx *nctx =
-            talloc_get_type(cctx->rctx->pvt_ctx, struct nss_ctx);
+    struct nss_ctx *nctx;
+    struct nss_state_ctx *state_ctx;
 
     DEBUG(SSSDBG_TRACE_FUNC, "Received setservent request\n");
 
+    nctx = talloc_get_type(cctx->rctx->pvt_ctx, struct nss_ctx);
+    state_ctx = talloc_get_type(cctx->state_ctx, struct nss_state_ctx);
+
     /* Reset the read pointers */
-    cctx->svc_dom_idx = 0;
-    cctx->svcent_cur = 0;
+    state_ctx->svcent.dom_idx = 0;
+    state_ctx->svcent.cur = 0;
 
     req = tevent_req_create(mem_ctx, &state, struct setservent_ctx);
     if (!req) return NULL;
@@ -1616,7 +1627,9 @@ nss_cmd_setservent_done(struct tevent_req *req)
     errno_t ret;
     struct nss_cmd_ctx *cmdctx =
             tevent_req_callback_data(req, struct nss_cmd_ctx);
+    struct cli_protocol *pctx;
 
+    pctx = talloc_get_type(cmdctx->cctx->protocol_ctx, struct cli_protocol);
     ret = setservent_recv(req);
     talloc_zfree(req);
     if (ret == EOK || ret == ENOENT) {
@@ -1624,9 +1637,9 @@ nss_cmd_setservent_done(struct tevent_req *req)
          * were eligible.
          * Return an acknowledgment
          */
-        ret = sss_packet_new(cmdctx->cctx->creq, 0,
-                             sss_packet_get_cmd(cmdctx->cctx->creq->in),
-                             &cmdctx->cctx->creq->out);
+        ret = sss_packet_new(pctx->creq, 0,
+                             sss_packet_get_cmd(pctx->creq->in),
+                             &pctx->creq->out);
         if (ret == EOK) {
             sss_cmd_done(cmdctx->cctx, cmdctx);
             return;
@@ -1653,6 +1666,7 @@ int nss_cmd_getservent(struct cli_ctx *cctx)
     struct nss_ctx *nctx;
     struct nss_cmd_ctx *cmdctx;
     struct tevent_req *req;
+    struct nss_state_ctx *state_ctx;
 
     DEBUG(SSSDBG_TRACE_FUNC,
           "Requesting info for all services\n");
@@ -1668,8 +1682,9 @@ int nss_cmd_getservent(struct cli_ctx *cctx)
      * expired and has to be recreated, we want to resume from the same
      * location.
      */
-    cmdctx->saved_dom_idx = cctx->svc_dom_idx;
-    cmdctx->saved_cur = cctx->svcent_cur;
+    state_ctx = talloc_get_type(cctx->state_ctx, struct nss_state_ctx);
+    cmdctx->saved_dom_idx = state_ctx->svcent.dom_idx;
+    cmdctx->saved_cur = state_ctx->svcent.cur;
 
     nctx = talloc_get_type(cctx->rctx->pvt_ctx, struct nss_ctx);
     if(!nctx->svcctx || !nctx->svcctx->ready) {
@@ -1695,6 +1710,7 @@ nss_cmd_implicit_setservent_done(struct tevent_req *req)
     errno_t ret;
     struct nss_cmd_ctx *cmdctx =
             tevent_req_callback_data(req, struct nss_cmd_ctx);
+    struct nss_state_ctx *state_ctx;
 
     ret = setservent_recv(req);
     talloc_zfree(req);
@@ -1711,8 +1727,9 @@ nss_cmd_implicit_setservent_done(struct tevent_req *req)
     }
 
     /* Restore the saved index and cursor locations */
-    cmdctx->cctx->svc_dom_idx = cmdctx->saved_dom_idx;
-    cmdctx->cctx->svcent_cur = cmdctx->saved_cur;
+    state_ctx = talloc_get_type(cmdctx->cctx->state_ctx, struct nss_state_ctx);
+    state_ctx->svcent.dom_idx = cmdctx->saved_dom_idx;
+    state_ctx->svcent.cur = cmdctx->saved_cur;
 
     ret = nss_cmd_getservent_immediate(cmdctx);
     if (ret != EOK) {
@@ -1726,31 +1743,33 @@ nss_cmd_implicit_setservent_done(struct tevent_req *req)
 static errno_t
 nss_cmd_getservent_immediate(struct nss_cmd_ctx *cmdctx)
 {
-    struct cli_ctx *cctx = cmdctx->cctx;
+    struct cli_protocol *pctx;
     uint8_t *body;
     size_t blen;
     uint32_t num;
     int ret;
 
+    pctx = talloc_get_type(cmdctx->cctx->protocol_ctx, struct cli_protocol);
+
     /* get max num of entries to return in one call */
-    sss_packet_get_body(cctx->creq->in, &body, &blen);
+    sss_packet_get_body(pctx->creq->in, &body, &blen);
     if (blen != sizeof(uint32_t)) {
         return EINVAL;
     }
     SAFEALIGN_COPY_UINT32(&num, body, NULL);
 
     /* create response packet */
-    ret = sss_packet_new(cctx->creq, 0,
-                         sss_packet_get_cmd(cctx->creq->in),
-                         &cctx->creq->out);
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret != EOK) {
         return ret;
     }
 
-    ret = retservent(cctx, num);
+    ret = retservent(cmdctx->cctx, num);
 
-    sss_packet_set_error(cctx->creq->out, ret);
-    sss_cmd_done(cctx, cmdctx);
+    sss_packet_set_error(pctx->creq->out, ret);
+    sss_cmd_done(cmdctx->cctx, cmdctx);
 
     return EOK;
 }
@@ -1758,6 +1777,8 @@ nss_cmd_getservent_immediate(struct nss_cmd_ctx *cmdctx)
 static errno_t
 retservent(struct cli_ctx *cctx, int num)
 {
+    struct cli_protocol *pctx;
+    struct nss_state_ctx *state_ctx;
     struct nss_ctx *nctx;
     struct getent_ctx *svcctx;
     struct ldb_message **msgs = NULL;
@@ -1765,59 +1786,65 @@ retservent(struct cli_ctx *cctx, int num)
     unsigned int n = 0;
     int ret = ENOENT;
 
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+    state_ctx = talloc_get_type(cctx->state_ctx, struct nss_state_ctx);
     nctx = talloc_get_type(cctx->rctx->pvt_ctx, struct nss_ctx);
     if (!nctx->svcctx) goto none;
 
     svcctx = nctx->svcctx;
 
     while (ret == ENOENT) {
-        if (cctx->svc_dom_idx >= svcctx->num) break;
+        if (state_ctx->svcent.dom_idx >= svcctx->num) break;
 
-        pdom = &svcctx->doms[cctx->svc_dom_idx];
+        pdom = &svcctx->doms[state_ctx->svcent.dom_idx];
 
-        n = pdom->res->count - cctx->svcent_cur;
-        if (n <= 0 && (cctx->svc_dom_idx+1 < svcctx->num)) {
-            cctx->svc_dom_idx++;
-            pdom = &svcctx->doms[cctx->svc_dom_idx];
+        n = pdom->res->count - state_ctx->svcent.cur;
+        if (n <= 0 && (state_ctx->svcent.dom_idx+1 < svcctx->num)) {
+            state_ctx->svcent.dom_idx++;
+            pdom = &svcctx->doms[state_ctx->svcent.dom_idx];
             n = pdom->res->count;
-            cctx->svcent_cur = 0;
+            state_ctx->svcent.cur = 0;
         }
 
         if (!n) break;
 
         if (n > num) n = num;
 
-        msgs = &(pdom->res->msgs[cctx->svcent_cur]);
+        msgs = &(pdom->res->msgs[state_ctx->svcent.cur]);
 
-        ret = fill_service(cctx->creq->out,
+        ret = fill_service(pctx->creq->out,
                            pdom->domain,
                            NULL, msgs,
                            &n);
 
-        cctx->svcent_cur += n;
+        state_ctx->svcent.cur += n;
     }
 
 none:
     if (ret == ENOENT) {
-        ret = sss_cmd_empty_packet(cctx->creq->out);
+        ret = sss_cmd_empty_packet(pctx->creq->out);
     }
     return ret;
 }
 
 int nss_cmd_endservent(struct cli_ctx *cctx)
 {
+    struct cli_protocol *pctx;
+    struct nss_state_ctx *state_ctx;
     struct nss_ctx *nctx;
     int ret;
 
     DEBUG(SSSDBG_TRACE_FUNC,
           "Terminating request info for all accounts\n");
 
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+    state_ctx = talloc_get_type(cctx->state_ctx, struct nss_state_ctx);
     nctx = talloc_get_type(cctx->rctx->pvt_ctx, struct nss_ctx);
 
     /* create response packet */
-    ret = sss_packet_new(cctx->creq, 0,
-                         sss_packet_get_cmd(cctx->creq->in),
-                         &cctx->creq->out);
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
 
     if (ret != EOK) {
         return ret;
@@ -1825,8 +1852,8 @@ int nss_cmd_endservent(struct cli_ctx *cctx)
     if (nctx->svcctx == NULL) goto done;
 
     /* Reset the indices so that subsequent requests start at zero */
-    cctx->svc_dom_idx = 0;
-    cctx->svcent_cur = 0;
+    state_ctx->svcent.dom_idx = 0;
+    state_ctx->svcent.cur = 0;
 
 done:
     sss_cmd_done(cctx, NULL);
diff --git a/src/responder/pac/pacsrv.c b/src/responder/pac/pacsrv.c
index 20a5702e1cf4bfdd390ff72e8cbb00ee7b4ca964..e69f64ab42eb45836ade279c28adc6bf5fb40248 100644
--- a/src/responder/pac/pacsrv.c
+++ b/src/responder/pac/pacsrv.c
@@ -125,6 +125,7 @@ int pac_process_init(TALLOC_CTX *mem_ctx,
                            PAC_SBUS_SERVICE_VERSION,
                            &monitor_pac_methods,
                            "PAC", &pac_dp_methods.vtable,
+                           sss_connection_setup,
                            &rctx);
     if (ret != EOK) {
         DEBUG(SSSDBG_FATAL_FAILURE, "sss_process_init() failed\n");
diff --git a/src/responder/pac/pacsrv_cmd.c b/src/responder/pac/pacsrv_cmd.c
index 64c02e81cb02c28ed14635a6532fc72253a83481..dbf7003ed7cf6a0c635f73ac0eb86bb599025ea4 100644
--- a/src/responder/pac/pacsrv_cmd.c
+++ b/src/responder/pac/pacsrv_cmd.c
@@ -26,6 +26,7 @@
 
 static errno_t pac_cmd_done(struct cli_ctx *cctx, int cmd_ret)
 {
+    struct cli_protocol *pctx;
     int ret;
 
     if (cmd_ret == EAGAIN) {
@@ -33,15 +34,17 @@ static errno_t pac_cmd_done(struct cli_ctx *cctx, int cmd_ret)
         return EOK;
     }
 
-    ret = sss_packet_new(cctx->creq, 0, sss_packet_get_cmd(cctx->creq->in),
-                         &cctx->creq->out);
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+
+    ret = sss_packet_new(pctx->creq, 0, sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret != EOK) {
         DEBUG(SSSDBG_OP_FAILURE, "sss_packet_new failed [%d][%s].\n",
                                   ret, strerror(ret));
         return ret;
     }
 
-    sss_packet_set_error(cctx->creq->out, cmd_ret);
+    sss_packet_set_error(pctx->creq->out, cmd_ret);
 
     sss_cmd_done(cctx, NULL);
 
@@ -105,8 +108,11 @@ static errno_t pac_add_pac_user(struct cli_ctx *cctx)
     struct pac_req_ctx *pr_ctx;
     struct tevent_req *req;
     enum idmap_error_code err;
+    struct cli_protocol *pctx;
 
-    sss_packet_get_body(cctx->creq->in, &body, &blen);
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+
+    sss_packet_get_body(pctx->creq->in, &body, &blen);
 
     pr_ctx = talloc_zero(cctx, struct pac_req_ctx);
     if (pr_ctx == NULL) {
diff --git a/src/responder/pam/pamsrv.c b/src/responder/pam/pamsrv.c
index a63b52ec173342b6089adb5d7131cdc2d8a526d2..b12918f83e5fd76d3b9adc27ec9ed04217a1c7bf 100644
--- a/src/responder/pam/pamsrv.c
+++ b/src/responder/pam/pamsrv.c
@@ -204,6 +204,7 @@ static int pam_process_init(TALLOC_CTX *mem_ctx,
                            SSS_PAM_SBUS_SERVICE_VERSION,
                            &monitor_pam_methods,
                            "PAM", &pam_dp_methods.vtable,
+                           sss_connection_setup,
                            &rctx);
     if (ret != EOK) {
         DEBUG(SSSDBG_FATAL_FAILURE, "sss_process_init() failed\n");
